package cn.com.infosec.asn1.tsp;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.cmp.PKIStatusInfo;
import cn.com.infosec.asn1.cms.ContentInfo;
import java.util.Enumeration;

public class TimeStampResp extends ASN1Encodable {
   PKIStatusInfo pkiStatusInfo;
   ContentInfo timeStampToken;

   public static TimeStampResp getInstance(Object o) {
      if (o != null && !(o instanceof TimeStampResp)) {
         if (o instanceof ASN1Sequence) {
            return new TimeStampResp((ASN1Sequence)o);
         } else {
            throw new IllegalArgumentException("unknown object in 'TimeStampResp' factory : " + o.getClass().getName() + ".");
         }
      } else {
         return (TimeStampResp)o;
      }
   }

   public TimeStampResp(ASN1Sequence seq) {
      Enumeration seq1;
      this.pkiStatusInfo = PKIStatusInfo.getInstance((seq1 = seq.getObjects()).nextElement());
      if (seq1.hasMoreElements()) {
         this.timeStampToken = ContentInfo.getInstance(seq1.nextElement());
      }

   }

   public TimeStampResp(PKIStatusInfo pkiStatusInfo, ContentInfo timeStampToken) {
      this.pkiStatusInfo = pkiStatusInfo;
      this.timeStampToken = timeStampToken;
   }

   public PKIStatusInfo getStatus() {
      return this.pkiStatusInfo;
   }

   public ContentInfo getTimeStampToken() {
      return this.timeStampToken;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10001 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var10001.add(this.pkiStatusInfo);
      ContentInfo var2;
      if ((var2 = this.timeStampToken) != null) {
         var1.add(var2);
      }

      return new DERSequence(var1);
   }
}
